package  {
	public class Projectile extends Actor {
		var type:Object;
		var clip:Solids = null;
		var velx:Number = 0;
		var vely:Number = 0;
		var creator:Pawn = null;
		var landed:Boolean = false;
		var nextLand:Number = 0;
		
		public function Projectile(_x:Number, _y:Number, _velx:Number, _vely:Number, _type:Object, _creator:Pawn) {
			var lambda:Number = 0;
			
			type = _type;
			x = _x;
			y = _y;
			velx = _velx;
			vely = _vely;
			
			lambda = Misc.Length(velx, vely);
			if (lambda > 0.1) {
				velx = velx * type.speed / lambda;
				vely = vely * type.speed / lambda;
			}
			
			creator = _creator;
			
			clip = new Solids;
			clip.gotoAndStop(type.frame);
			addChild(clip);
			
			nextLand = g.time + type.maxTime;
			
			AddToLayer(g.layerTop);
			AddEventListener(GEvent.Tick, Tick);
			AddEventListener(GEvent.OnTimeOver, OnTimeOver);
			Tick(null);
		}
		
		public function Tick(e:GEvent):void {
			var i:int;
			
			if (landed) {
				
			}
			else {
				if (type == T.proj_javelin) {
					rotation = Misc.ToDegrees(Math.atan2(vely, velx));
				}
				
				x += velx * T.dt;
				y += vely * T.dt;
				
				if (type == T.proj_javelin) {
					for (i = 0; i < g.enemies.length; i++) {
						var en:Enemy = g.enemies[i];
						if (en.PointInside(x, y)) {
							en.Hurt(type.damage, this);
							Kill();
							return;
						}
					}
					for (i = 0; i < g.giants.length; i++) {
						var giant:Giant = g.giants[i];
						if (giant.PointInside(x, y)) {
							giant.Hurt(type.damage, this);
							Kill();
							return;
						}
					}
				}
				else {
					for (i = 0; i < g.spirits.length; i++) {
						var spirit:Spirit = g.spirits[i];
						if (spirit.type.color == type.color && spirit.PointInside(x, y)) {
							spirit.TakeDamage(type.damage);
							Kill();
							return;
						}
					}
				}
				
				if (nextLand < g.time) {
					if (type == T.proj_javelin ) {
						clip.gotoAndStop(2);
						landed = true;
						return;
					}
					else {
						Kill();
					}
				}
			}
		}
		
		public function OnTimeOver(e:GEvent):void {
			Kill();
		}
	}
}


































